=== debian/changelog ===
toppic (1.3.0+dfsg1-4build1) hirsute; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 12 Dec 2020 13:20:25 +0100

toppic (1.3.0+dfsg1-4) unstable; urgency=low

  * Fix the URLs for the VCS.

  * Make sure the build flags are handled correctly.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 11 Nov 2020 18:36:47 +0100

toppic (1.3.0+dfsg1-3) unstable; urgency=low

  * Reinstating the ITP bug closing statement (Closes: #961085).

  * Patch the build system so that the external libpwiz subset code that is
    included is not used. Instead, link to the pwizlite library that I have
    created and packaged for Debian. Use CMake to find libpwizlite and libhts.

  * Remove from the d/copyright all the stanzas related to the pwiz/boost code
    since it does not belong to the cleaned package anymore. Add the
    corresponding files to the Files-Excluded stanza.

  * d/s/lintian-overrides: override E for missing sources files that are
    genuine package authors' code (lintian is triggered by long lines > 512
    chars).

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 03 Nov 2020 09:28:06 +0100

toppic (1.3.0+dfsg1-2) unstable; urgency=low

  * Fixes to the packaging.

  * Reinstating bug closing statement (Closes: #961085).

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 04 Jun 2020 00:09:22 +0200

toppic (1.3.0+dfsg1-1) unstable; urgency=medium

  * Initial release (Closes: #961085).

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 19 May 2020 22:46:41 +0200
