=== debian/watch ===
version=4

opts="repack, \
repacksuffix=+dfsg, \
compression=gzip, \
dversionmangle=s/\+dfsg\d*$//, \
filenamemangle=s%(?:.*?)?v?(\d[\d\.]*)\.tar\.gz%toppic-$1.tar.gz%" \
https://github.com/toppic-suite/toppic-suite/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz \
debian \
uupdate
