=== debian/changelog ===
toppic (1.5.3+dfsg1-1) unstable; urgency=low

  * Repackaged source tree to actually remove doc/wiki.
  * Fixes to license names and small designations (Boost, MIT).
  * Also ship example files in toppic-common doc.

 -- Filippo Rusconi <lopippo@debian.org>  Sun, 30 Oct 2022 22:51:42 +0100

toppic (1.5.3+dfsg-1) unstable; urgency=medium

  * Team upload.
  * Drop redundant parts from d/watch that are confusing routine-update
  * Standards-Version: 4.6.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Remove trailing whitespace in debian/control (routine-update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Trim trailing whitespace.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Contact, Name,
    Repository, Repository-Browse.
  * Build-Depends: libeigen3-dev, nlohmann-json3-dev

  * Patch-based fixes to CMakeLists.txt to ensure all the _gui variants of the
    programs are shipped.
  * Update d/copyright

 -- Filippo Rusconi <lopippo@debian.org>  Sun, 30 Oct 2022 15:03:26 +0100
