=== debian/rules ===
--- 
+++ 
@@ -26,7 +26,10 @@
 	rst2man debian/topmg.1.rst > debian/topmg.1
 	rst2man debian/topdiff.1.rst > debian/topdiff.1
 
+# Note that here thre prefix needs to be "/" because of the CMakeLists.txt
+# file that says install like this:
+# install (TARGETS topfd toppic topmg topdiff topindex topmerge DESTINATION ${CMAKE_INSTALL_PREFIX}/usr/bin/)
+# install (DIRECTORY toppic_resources/ DESTINATION ${CMAKE_INSTALL_PREFIX}/etc/toppic)
 	dh_auto_configure -- \
-		-DCMAKE_INSTALL_PREFIX="/usr" \
+		-DCMAKE_INSTALL_PREFIX="/" \
 		-DCMAKE_BUILD_TYPE=release
-
